#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "mcutil.h"
#include "collect/gen_vec.h"

MCU_API void mcu_gen_vec_init(gen_vec_t* gv) {
    gv->inner = MCU_ALLOC(sizeof(void*)*MCU_GEN_VEC_INITIAL_SIZE); 
    gv->capacity  = MCU_GEN_VEC_INITIAL_SIZE;
}


MCU_API void mcu_gen_vec_insert_front(gen_vec_t* gv, void* data) {
    assert(gv && "Null ptr passed as gen_vec_t");
    if (!gv->inner) mcu_gen_vec_init(gv);
    if (gv->count == gv->capacity) {
        gv->inner = MCU_REALLOC(gv->inner, (gv->capacity * sizeof(void*)) * 2);
        gv->capacity *= 2;
    }

    size_t count = sizeof(void*)*gv->count;
    void* tmp = MCU_ALLOC(count);
    memcpy(tmp, gv->inner, count);
    memcpy(gv->inner + sizeof(void*), tmp, count);
    gv->inner[0] = data;
    MCU_FREE(tmp);
}

MCU_API void mcu_gen_vec_insert_back(gen_vec_t* gv, void* data) {
    assert(gv && "Null ptr passed as gen_vec_t");
    if (!gv->inner) mcu_gen_vec_init(gv);
    if (gv->count == gv->capacity) {
        gv->inner = MCU_REALLOC(gv->inner, (gv->capacity * sizeof(void*)) * 2);
        gv->capacity *= 2;
    }
    gv->inner[gv->count++] = data;
}

MCU_API void* mcu_gen_vec_remove_back(gen_vec_t *gv) {
    assert(gv && "Null ptr passed as gen_vec_t");
    if (gv->count == 0) return NULL;
    return gv->inner[gv->count--];
}

MCU_API void* mcu_gen_vec_remove_front(gen_vec_t *gv) {
    assert(gv && "Null ptr passed as gen_vec_t");
    if (gv->count == 0) return NULL;
    void* data = gv->inner[0];
    size_t count = sizeof(void*)*gv->count;
    void* tmp = MCU_ALLOC(count);
    memcpy(tmp, gv->inner, count);
    memcpy(gv->inner - sizeof(void*), tmp, count);
    MCU_FREE(tmp);
    gv->count--;
    return data;
}
